# Importation des modules

import pygame
from pygame.locals import *
import sys
import random

WHITE = (255, 255, 255)

class SardJump (object):
    def __init__(self):
        pygame.font.init() # Initie les fonctions pour la police via pygame
        self.screen = pygame.display.set_mode((800, 600)) # Défini taille de la fenêtre
        # Défini les assets et valeurs par défaut
        self.playerRight_1 = pygame.image.load("assets/right_1.png").convert_alpha()
        self.playerRight = pygame.image.load("assets/right.png").convert_alpha()
        self.playerLeft = pygame.image.load("assets/left.png").convert_alpha()
        self.playerLeft_1 = pygame.image.load("assets/left_1.png").convert_alpha()
        self.cameray = 0
        self.playerx = 400
        self.playery = 400
        self.xmovement = 0
        self.jump = 0
        self.direction = 0
        self.gravity = 0
        self.plateform = pygame.image.load("assets/plateform.png").convert_alpha()
        self.background = pygame.image.load("assets/bg.png").convert()
        self.platforms = [[400, 500]]
        self.score = 0 # Défini le score

    # Intéractions joueur
    def updatePlayer(self):
        global score
        if self.playerx > 850:
            self.playerx = -50
        elif self.playerx < -50:
            self.playerx = 850
        self.playerx += self.xmovement
        if self.playery - self.cameray <= 200:
            self.cameray -= 10
            score += 1 # Update du score

        # Changement de skin lors d'un nombre de point.
        if score >= 1000:
            self.playerRight_1 = pygame.image.load("assets/right_skin1000_1.png").convert_alpha()
            self.playerRight = pygame.image.load("assets/right_skin1000.png").convert_alpha()
            self.playerLeft_1 = pygame.image.load("assets/left_skin1000_1.png").convert_alpha()
            self.playerLeft = pygame.image.load("assets/left_skin1000.png").convert_alpha()
        if score >= 10000:
            self.background = pygame.image.load("assets/bg_qlf.png").convert()
            self.playerRight_1 = pygame.image.load("assets/right_skin10000_1.png").convert_alpha()
            self.playerRight = pygame.image.load("assets/right_skin10000.png").convert_alpha()
            self.playerLeft_1 = pygame.image.load("assets/left_skin10000_1.png").convert_alpha()
            self.playerLeft = pygame.image.load("assets/left_skin10000.png").convert_alpha()

        if not self.direction:
            if self.jump:
                self.screen.blit(self.playerRight_1,
                                 (self.playerx, self.playery - self.cameray))
            else:
                self.screen.blit(self.playerRight,
                                 (self.playerx, self.playery - self.cameray))
        else:
            if self.jump:
                self.screen.blit(self.playerLeft_1,
                                 (self.playerx, self.playery - self.cameray))
            else:
                self.screen.blit(
                    self.playerLeft, (self.playerx, self.playery - self.cameray))
        key = pygame.key.get_pressed()
        # Bouger le personnage vers la droite
        if key[K_RIGHT]:
            if self.xmovement < 10:
                self.xmovement += 1
                self.direction = 0
        # Bouger le personnage vers la gauche
        elif key[K_LEFT]:
            if self.xmovement > -10:
                self.xmovement -= 1
                self.direction = 1
        # Changer le skin des plateformes
        elif key[K_UP]:
            self.plateform = pygame.image.load("assets/plateform.png").convert_alpha()
        elif key[K_DOWN]:
            self.plateform = pygame.image.load("assets/plateform_piano.png").convert_alpha()
        else:
            if self.xmovement > 0:
                self.xmovement -= 1
            elif self.xmovement < 0:
                self.xmovement += 1
        if not self.jump:
            self.playery += self.gravity
            self.gravity += 1
        elif self.jump:
            self.playery -= self.jump
            self.jump -= 1

    # Afficher les plateformes
    def drawPlatforms(self):
        for plat in self.platforms:
            regenerate = self.platforms[1][1] - self.cameray
            if regenerate > 600:
                self.platforms.append(
                    (random.randint(0, 700), self.platforms[-1][1] - 50))
                self.platforms.pop(0)
            self.screen.blit(
                    self.plateform, (plat[0], plat[1] - self.cameray))
    # Générer les plateformes
    def generatePlatforms(self):
        y = 700
        while y > -100:
            x = random.randint(0, 900)
            self.platforms.append((x, y))
            y -= 50
    # Collision entre le joueur et les plateformes (permet que le joueur ne tombe pas)
    def updatePlatforms(self):
        for p in self.platforms:
            rect = pygame.Rect(
                p[0], p[1], self.plateform.get_width() - 10, self.plateform.get_height())
            player = pygame.Rect(self.playerx, self.playery,
                                 self.playerRight.get_width() - 10, self.playerRight.get_height())
            if rect.colliderect(player) and self.gravity and self.playery < (p[1] - self .
                                                                             cameray):
                self.jump = 15
                self.gravity = 0
    # Lancement du jeu
    def run(self):
        global score
        score = 0 # Définition du score
        clock = pygame.time.Clock()
        self.generatePlatforms()
        while True:
            self.screen.fill(WHITE)
            self.screen.blit(self.background,(0,0)) # Affiche l'image choisie en fond
            FONT = pygame.font.Font('assets/fonts/Optimus.otf', 30) # Sélectionne une police custom
            text = FONT.render("Score : " + str(score),False,(255,255,255)).convert_alpha() # Crée le texte du score (sans fond)
            clock.tick(60)

            for event in pygame.event.get():
                if event.type == QUIT:
                    sys.exit()
            if self.playery - self.cameray > 700:
                # Reset des valeurs par défaut (score, skin, arrière plan, plateformes, etc)
                score = 0
                self.playerRight_1 = pygame.image.load("assets/right_1.png").convert_alpha()
                self.playerRight = pygame.image.load("assets/right.png").convert_alpha()
                self.playerLeft = pygame.image.load("assets/left.png").convert_alpha()
                self.playerLeft_1 = pygame.image.load("assets/left_1.png").convert_alpha()
                self.background = pygame.image.load("assets/bg.png").convert()
                self.cameray = 0
                self.platforms = [[400, 500]]
                self.generatePlatforms()
                self.playerx = 400
                self.playery = 400
                
            self.drawPlatforms()
            self.updatePlatforms()
            self.updatePlayer()
            self.screen.blit(text, (550, 50))
            pygame.display.flip() # Actualise le code
            pygame.display.set_caption("SardJump") # Affiche le titre de la fenêtre

SardJump().run()
